/**
    Copyright (c) 2021 NIBIO <http://www.nibio.no/>. 

    This file is part of Model_GENPHENOLO.  
    Model_GENPHENOLO is free software: you can redistribute it and/or modify  
    it under the terms of the NIBIO Open Source License as published by  
    NIBIO, either version 1 of the License, or (at your option) any 
    later version. 

    Model_GENPHENOLO is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
    NIBIO Open Source License for more details. 

    You should have received a copy of the NIBIO Open Source License 
    along with Model_GENPHENOLO.  If not, see <http://www.nibio.no/licenses/>.
 */
package no.nibio.vips.model.phenology;

import no.nibio.vips.util.DateMap;

/**
 *
 * @author Bhabesh Bhabani Mukhopadyay
 * @author Tor-Einar Skog <tor-einar.skog@nibio.no>
 */
public class DataMatrix extends DateMap
{
     public final static String  TEMPERATURE_MEAN              =   "TM";           //  Mean Temperature
     public final static String  TEMPERATURE_MAX               =   "TX";           //  Max Temperature
     public final static String  TEMPERATURE_MIN               =   "TN";           //  Min Temperature
     public final static String  TEMPERATURE_DAILY_TIME        =   "DTT";          //  Daily Temperature Time
     
     public final static String  TEMP_NON_NEGATIVE              =   "NON_NEG";
     public final static Double  BASE_TEMP_VALUE                =   10.0;
     
     public final static String  PARAM_PHENOLOGYM_VARIETY       =   "VARIETY";
     public final static String  PARAM_PHENOLOGYM_PHASE         =   "PHASE";
     public final static String  PARAM_HEAT_SUM                 =   "HEATSUM";
     public final static String  PARAM_HEAT_REQUIREMENT         =   "HEATREQ";
          
     public final static String PLANTATION_DATA                =   "plantationData";
     public final static String PARAM_BIOFIX                =   "startDate";


     
     
     
     
     
     
}
