/**
    Copyright (c) 2021 NIBIO <http://www.nibio.no/>. 

    This file is part of Model_GENPHENOLO.  
    Model_GENPHENOLO is free software: you can redistribute it and/or modify  
    it under the terms of the NIBIO Open Source License as published by  
    NIBIO, either version 1 of the License, or (at your option) any 
    later version. 

    Model_GENPHENOLO is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
    NIBIO Open Source License for more details. 

    You should have received a copy of the NIBIO Open Source License 
    along with Model_GENPHENOLO.  If not, see <http://www.nibio.no/licenses/>.
 */
package no.nibio.vips.model.phenology;

/**
 *
 * @author Bhabesh Bhabani Mukhopadyay
 * @author Tor-Einar Skog <tor-einar.skog@nibio.no>
 */
public class PhenologyModelStore {
    
    private PhenologyModelStore(){ }
    private static PhenologyModelStore instance = null;
    
    private static void activateStore()
    {
        
    }
    
    public Double dayDegreeModel(Double tm_daily, Double heatSum, Double baseTempValue)
    {
            Double              tm_nonNegative      =   getNonNegative(tm_daily, baseTempValue); //tm_nonNegative + ((tm_calculate < 0)? 0 : tm_calculate);
                                heatSum             =   heatSum + tm_nonNegative;
            return heatSum;                    
    }
    
    
    
    public Double hourlyMeanWithBaseMaxAndOptTemp(Double tm, Double tb, Double tOpt, Double tu)
    {
        Double f1, f2, f3, f4   =   0.0;
        Double p1, p2, p3, p4   =   0.0;
        Double htt              =   0.0;
        
        f1 =    tm   -  tb;
        f2 =    tOpt - tb;
        f3 =    tu  - tm;
        f4 =    tu  - tOpt;
        
        p1  =   f1 / f2;
        p2  =   f3 / f4;
        p3  =   f4/ f2;
        p4  =   Math.pow(p2, p3);
        
        htt = (tm < tb)? 0.0 : (tm<tb)? 0.0 : (p1 * f2 * p4 );
        
        return htt;
        
    }
    
    
        /**
     * 
     * @param tm_daily
     * @return 
     */
    public Double getNonNegative(Double tm_daily, Double baseTempValue){
            Double              tm_calculate        =   0.0;
            Double              tm_nonNegative      =   0.0;
                                tm_calculate        =   tm_daily - baseTempValue;
                                tm_nonNegative      =   tm_nonNegative + ((tm_calculate < 0)? 0 : tm_calculate);
        
        return tm_nonNegative;
    }
    
    public static PhenologyModelStore getInstance()
    {
        if(instance == null)
        {
            instance    =   new PhenologyModelStore();
            
        }
        
        return instance;
    }
}
