/**
    Copyright (c) 2021 NIBIO <http://www.nibio.no/>. 

    This file is part of Model_GENPHENOLO.  
    Model_GENPHENOLO is free software: you can redistribute it and/or modify  
    it under the terms of the NIBIO Open Source License as published by  
    NIBIO, either version 1 of the License, or (at your option) any 
    later version. 

    Model_GENPHENOLO is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
    NIBIO Open Source License for more details. 

    You should have received a copy of the NIBIO Open Source License 
    along with Model_GENPHENOLO.  If not, see <http://www.nibio.no/licenses/>.
 */
package no.nibio.vips.model.phenology;

import java.util.Date;
import java.util.List;

/**
 *
 * @author Bhabesh Bhabani Mukhopadyay
 * @author Tor-Einar Skog <tor-einar.skog@nibio.no>
 */
public class Plant {
   private String              speciesLatinName;
    private String              typeName;
    private Double              baseTemp;
    private Double              optTemp;                                        /* Optimum temperature */
    private Double              upperTemp;                                      /* Upper temperature */    
    private Integer             logIntervalId;
    private Integer             algorithmId;
    private Date                startDate;
    private String[]            weatherParams;
    
    private List<Plantation>    plantations;

    public String getSpeciesLatinName() {
        return speciesLatinName;
    }

    public void setSpeciesLatinName(String speciesLatinName) {
        this.speciesLatinName = speciesLatinName;
    }

    public String getTypeName() {
        return typeName;
    }

    public void setTypeName(String typeName) {
        this.typeName = typeName;
    }

    public Double getBaseTemp() {
        return baseTemp;
    }

    public void setBaseTemp(Double baseTemp) {
        this.baseTemp = baseTemp;
    }

    public Double getOptTemp() {
        return optTemp;
    }

    public void setOptTemp(Double optTemp) {
        this.optTemp = optTemp;
    }

    public Double getUpperTemp() {
        return upperTemp;
    }

    public void setUpperTemp(Double upperTemp) {
        this.upperTemp = upperTemp;
    }

    public Integer getLogIntervalId() {
        return logIntervalId;
    }

    public void setLogIntervalId(Integer logIntervalId) {
        this.logIntervalId = logIntervalId;
    }

    public Integer getAlgorithmId() {
        return algorithmId;
    }

    public void setAlgorithmId(Integer algorithmId) {
        this.algorithmId = algorithmId;
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    public List<Plantation> getPlantations() {
        return plantations;
    }

    public void setPlantations(List<Plantation> plantations) {
        this.plantations = plantations;
    }

    public String[] getWeatherParams() {
        return weatherParams;
    }

    public void setWeatherParams(String[] weatherParams) {
        this.weatherParams = weatherParams;
    }

    @Override
    public String toString() {
        return "Plant{" + "speciesLatinName=" + speciesLatinName + ", typeName=" + typeName + ", baseTemp=" + baseTemp + ", optTemp=" + optTemp + ", upperTemp=" + upperTemp + ", logIntervalId=" + logIntervalId + ", algorithmId=" + algorithmId + ", startDate=" + startDate + ", weatherParams=" + weatherParams + ", plantations=" + plantations + '}';
    }


        
}
